/* o(2^n * n) */
#include<bits/stdc++.h>

using namespace std;

#define dbg(x) (cout<<#x<<" = "<<(x)<<'\n')

typedef long long int lld;
const int INF = (1LL << 30) - 1;
const lld LINF = (1LL << 62) - 1;
const int NMAX = 1e5;

int N, sol, MASK;
char initial[NMAX + 5];
char final[NMAX + 5];
char aux[NMAX + 5];
char solini[NMAX + 5];

void verif_valid() {
	assert(final[1] != '1');
	for (int i = 2; i <= N; i++)
		if (final[i] == '1')
			for (int j = 2 * i; j <= N; j += i) {
				// printf("%d %d\n", i, j);
				// fflush(stdout);
				assert(final[j] != '1');
			}
}

int main() {
	cin.sync_with_stdio(false);

	#ifndef ONLINE_JUDGE
	freopen("ciurulet.in", "r", stdin);
	freopen("ciurulet.out", "w", stdout);
	#endif

	scanf("%d", &N);
	scanf("%s", final + 2);

	verif_valid();

	MASK = (1 << N) - 1;
	for (int mask = MASK - 1; mask >= 0; mask--) {
		if (__builtin_popcount(mask) < sol)
			continue;

		for (int i = 0; i < N - 1; i++)
			initial[i + 2] = '0' + ((mask & (1 << i)) != 0);

		memcpy(aux, initial, sizeof(initial));

		for (int i = 2; i <= N; i++)
			if (aux[i] == '1')
				for (int j = 2 * i; j <= N; j += i)
					aux[j] = '0';

		bool bad = false;

		for (int i = 2; i <= N; i++)
			if (aux[i] != final[i] && final[i] != '?') {
				bad = true;
				break;
			}

		if (!bad) {
			int ans = 0;
			for (int i = 2; i <= N; i++)
				ans += initial[i] - '0';
			sol = max(sol, ans);
			memcpy(solini, initial, sizeof(solini));
		}
	}

	printf("%d\n", sol);

	printf("%s\n", solini + 2);

	return 0;
}
