/* O(Nsqrt(N)) */
#include<bits/stdc++.h>

using namespace std;

#define dbg(x) (cout<<#x<<" = "<<(x)<<'\n')

typedef long long int lld;
const int INF = (1LL << 30) - 1;
const lld LINF = (1LL << 62) - 1;
const int NMAX = 1e5;

int N;
char initial[NMAX + 5];
char final[NMAX + 5];

void verif_valid() {
	for (int i = 2; i <= N; i++)
		if (final[i] == '1')
			for (int j = 2 * i; j <= N; j += i) {
				// printf("%d %d\n", i, j);
				// fflush(stdout);
				assert(final[j] != '1');
			}
}

int main() {
	cin.sync_with_stdio(false);

	#ifndef ONLINE_JUDGE
	freopen("ciurulet.in", "r", stdin);
	freopen("ciurulet.out", "w", stdout);
	#endif

	scanf("%d", &N);
	scanf("%s", final + 2);

	memset(initial, 0, sizeof(initial));

	verif_valid();

	// initial[1] = '0' + (final[1] != '0');

	for (int i = N; i >= 2; i--)
		if (final[i] == '1')
			for (int j = 2; j * j <= i; j++)
				if (i % j == 0)
					initial[j] = initial[i / j] = '0';

	for (int i = 2; i <= N; i++)
		if (!initial[i])
			initial[i] = '1';

	for (int i = 2; i <= N; i++) {
		int are_divizor_prim = 0;

		for (int j = 2; j * j <= i; j++)
			if (i % j == 0 && (initial[j] == '1' || initial[i / j] == '1'))
				are_divizor_prim = 1;

		if (final[i] == '0') initial[i] = '0' + are_divizor_prim;
	}

	int sol = 0;
	for (int i = 2; i <= N; i++)
		sol += initial[i] - '0';
	printf("%d\n", sol);

	printf("%s\n", initial + 2);

	return 0;
}
