#include<stdio.h>

#define NMAX 50006

int a[NMAX], b[NMAX], grad[NMAX], n, m;
double p0[NMAX], p1[NMAX];
double d[NMAX][2], newd[NMAX][2], ans;

int main ()
{
	freopen("network.in","r",stdin);
	freopen("network.out","w",stdout);
	
	scanf("%d%d",&n,&m);
	for(int i = 1; i <= m; i++)
	{
		scanf("%d%d%lf%lf",&a[i],&b[i],&p0[i],&p1[i]);
		a[i]++;b[i]++;
		grad[a[i]]++;		
	}
	
	d[1][0] = 1;
	d[1][1] = 0;
	for(int t = 40000000 / m; t; t--)
	{
		for(int i = 1; i <= m; i++)
		{
			newd[b[i]][0] += (d[a[i]][0] * p0[i] + d[a[i]][1] * (1 - p1[i])) / grad[a[i]];
			newd[b[i]][1] += (d[a[i]][1] * p1[i] + d[a[i]][0] * (1 - p0[i])) / grad[a[i]];
			//printf("%d %lf %lf\n", b[i], newd[b[i]][0], newd[b[i]][1]);
		}
		for(int i = 1; i <= n; i++)
		{
			d[i][0] = newd[i][0];
			d[i][1] = newd[i][1];
			newd[i][0] = newd[i][1] = 0;
		}
		ans += d[n][0];
	}
	printf("%.8lf\n", ans);
	
	d[1][0] = 0;
	d[1][1] = 1;
	ans = 0;
	for(int t = 40000000 / m; t; t--)
	{
		for(int i = 1; i <= m; i++)
		{
			newd[b[i]][0] += (d[a[i]][0] * p0[i] + d[a[i]][1] * (1 - p1[i])) / grad[a[i]];
			newd[b[i]][1] += (d[a[i]][1] * p1[i] + d[a[i]][0] * (1 - p0[i])) / grad[a[i]];
			//printf("%d %lf %lf\n", b[i], newd[b[i]][0], newd[b[i]][1]);
		}
		for(int i = 1; i <= n; i++)
		{
			d[i][0] = newd[i][0];
			d[i][1] = newd[i][1];
			newd[i][0] = newd[i][1] = 0;
		}
		ans += d[n][1];
	}
	printf("%.8lf\n", ans);
	
	return 0;
}


