#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <iomanip>
#define DN 5005
#define x first
#define y second
#define mp make_pair
using namespace std;

typedef pair<double,double> per;

int n,m;
vector<pair<int,per> > gr[DN];
vector<int> st;
bitset<DN> viz;
long double pb[DN][2];

void _st(int s) {
  viz[s]=1;
  for(auto i:gr[s]) if(!viz[i.x]) _st(i.x);
  st.push_back(s);
}

long double d(int b) {
  for(int i=0; i<n; ++i) pb[i][0]=pb[i][1]=0;
  pb[0][b]=1;
  for(int i=0; i<st.size(); ++i) {
    int s=st[i],k=gr[st[i]].size();
    //cout<<s<<' '<<pb[s][0]<<' '<<pb[s][1]<<'\n';
    for(auto v:gr[s]) {
      int nx=v.x; double p0=v.y.x,p1=v.y.y;
      pb[nx][0]=1.0/k*(p0*pb[s][0]+(1-p1)*pb[s][1]);
      pb[nx][1]=1.0/k*(p1*pb[s][1]+(1-p0)*pb[s][0]);
    }
  }
  return pb[n-1][b];
}

int main() {
  ifstream f("network.in");
  ofstream g("network.out");
  for(f>>n>>m;m--;) {
    int a,b; double c,d;
    f>>a>>b>>c>>d;
    gr[a].push_back(mp(b,mp(c,d)));
  }
  for(int i=0; i<n; ++i) if(!viz[i]) _st(i);
  reverse(st.begin(),st.end());

  g<<fixed<<setprecision(9)<<d(0)<<'\n'<<d(1);
}